import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:ocg_user/src/bloc/user/event.dart';
import 'package:ocg_user/src/bloc/user/state.dart';
import 'package:ocg_user/ocg_user.dart';

class UserBloc extends Bloc<UserEvent, UserState> {
  final UserRepository userRepository;
  UserBloc(this.userRepository) : super(UserIdleState());

  @override
  Stream<UserState> mapEventToState(UserEvent event) async* {
    if (event is UserLoadSelfEvent) {
      yield UserLoadingState();
      var response = await userRepository.getSelf();
      if (response.isSuccess) {
        yield UserLoadedState(response.data);
      } else {
        yield UserErrorState(response.error);
      }
    }
    if (event is UserLoadFriendEvent) {
      yield UserLoadingState();
      var response = await userRepository.getUser(event.userId);
      if (response.isSuccess) {
        yield UserLoadedState(response.data);
      } else {
        yield UserErrorState(response.error);
      }
    }
  }
}
