import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:ocg_app/ocg_app.dart';
import 'package:ocg_user/src/models/user.dart';
import 'package:ocg_user/src/repository/base.dart';

import 'event.dart';
import 'state.dart';

class UserListBloc extends Bloc<UserListEvent, UserListState> {
  final UserRepository userRepository;
  UserListBloc(this.userRepository) : super(UserListLoadingState());

  @override
  Stream<UserListState> mapEventToState(UserListEvent event) async* {
    if (event is UserListRefreshEvent) {
      AppResponse<List<User>> response = await userRepository.getAllUsers();
      if (response.isSuccess) {
        yield UserListLoadedState(response.data);
      } else {
        yield UserListErrorState(response.error.toString());
      }
    }
    if (event is UserListLoadEvent) {
      AppResponse<List<User>> response =
          await userRepository.getUsersList(event.userIds);
      if (response.isSuccess) {
        yield UserListLoadedState(response.data);
      } else {
        yield UserListErrorState(response.error.toString());
      }
    }
  }
}
