import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:ocg_app/ocg_app.dart';
import 'package:ocg_user/ocg_user.dart';
import 'package:ocg_user/src/bloc/user_status/state.dart';
import 'package:ocg_user/src/bloc/user_status/event.dart';
import 'package:ocg_user/src/models/user.dart';

class UserStatusBloc extends Bloc<UserStatusEvent, UserStatusState> {
  final UserRepository userRepository;
  UserStatusBloc(this.userRepository) : super(UserStatusInitialState());

  @override
  Stream<UserStatusState> mapEventToState(UserStatusEvent event) async* {
    if (event is UserStatusRefreshEvent) {
      yield UserStatusLoadingState(
        state.userId,
      );
      AppResponse<User> response = await userRepository.getUser(event.userId);
      if (response.isSuccess) {
        yield UserStatusOnlineState(state.userId, response.data.lastSeen);
      }
    }
  }
}
