import 'package:json_annotation/json_annotation.dart';
import 'package:ocg_app/ocg_app.dart';

part 'user.g.dart';

@JsonSerializable(explicitToJson: true)
class User {
  @JsonKey(name: "user_id")
  final String id;
  @JsonKey(name: "fullname")
  final String name;
  @JsonKey(name: "avatar")
  final String profilePic;
  final String status;
  final String email;
  final String password;
  final String phone;
  @JsonKey(defaultValue: false)
  final bool blocked;
  @JsonKey(
      name: "lastseen",
      fromJson: DateHelper.convertFromString,
      toJson: DateHelper.convertToString)
  final DateTime lastSeen;

  User(this.id, this.name, this.profilePic, this.status, this.email,
      this.password, this.phone, this.lastSeen, this.blocked);

  User.named(
      {this.id,
      this.name,
      this.profilePic,
      this.status,
      this.email,
      this.password,
      this.phone,
      this.lastSeen,
      this.blocked});

  Map<String, dynamic> toJson() => _$UserToJson(this);

  factory User.fromJson(json) => _$UserFromJson(json);

  User copyWith(
      {String id,
      String name,
      String profilePic,
      String status,
      String email,
      String password,
      DateTime lastSeen,
      bool blocked}) {
    return User.named(
        id: id ?? this.id,
        name: name ?? this.name,
        profilePic: profilePic ?? this.profilePic,
        status: status ?? this.status,
        email: email ?? this.email,
        password: password ?? this.password,
        lastSeen: lastSeen ?? this.lastSeen,
        phone: phone ?? this.phone,
        blocked: blocked ?? this.blocked);
  }
}
