import 'package:ocg_app/ocg_app.dart';
import 'package:ocg_user/src/models/user.dart';

abstract class UserRepository extends Crud<User> {
  final TokenRepository tokenRepository;

  UserRepository(this.tokenRepository);
  Future<AppResponse<User>> getSelf();
  Future<AppResponse<String>> getSelfId() async {
    AppResponse<AppToken> response = await tokenRepository.getToken();
    if (response.isSuccess) {
      return AppResponse.named(data: response.data.userId);
    }
    return AppResponse.named(error: response.error);
  }

  Future<AppResponse<bool>> updateSelf(User user);
  Future<AppResponse<bool>> blockUser(String userId, bool block);
  @Deprecated("Use read")
  Future<AppResponse<User>> getUser(String userId) async {
    return read(userId);
  }

  Future<AppResponse<List<User>>> getUsersList(List<String> userIds);

  @Deprecated("Use getList")
  Future<AppResponse<List<User>>> getAllUsers() async {
    return getList();
  }
}
